/**
 * jQuery Cookie plugin
 *
 * Copyright (c) 2010 Klaus Hartl (stilbuero.de)
 * Dual licensed under the MIT and GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 *
 */
jQuery.cookie = function (key, value, options) {

    // key and value given, set cookie...
    if (arguments.length > 1 && (value === null || typeof value !== "object")) {
        options = jQuery.extend({}, options);

        if (value === null) {
            options.expires = -1;
        }

        if (typeof options.expires === 'number') {
            var days = options.expires, t = options.expires = new Date();
            t.setDate(t.getDate() + days);
        }

        return (document.cookie = [
            encodeURIComponent(key), '=',
            options.raw ? String(value) : encodeURIComponent(String(value)),
            options.expires ? '; expires=' + options.expires.toUTCString() : '', // use expires attribute, max-age is not supported by IE
            options.path ? '; path=' + options.path : '',
            options.domain ? '; domain=' + options.domain : '',
            options.secure ? '; secure' : ''
        ].join(''));
    }

    // key and possibly options given, get cookie...
    options = value || {};
    var result, decode = options.raw ? function (s) { return s; } : decodeURIComponent;
    return (result = new RegExp('(?:^|; )' + encodeURIComponent(key) + '=([^;]*)').exec(document.cookie)) ? decode(result[1]) : null;
};

(function($, undefined)
{
	jQuery.fn.static_div = function(location)
	{
		var isIE6 = false;
		var Sys =
		{
		};
		var ua = navigator.userAgent.toLowerCase();
		var s;
		( s = ua.match(/msie ([\d.]+)/)) ? Sys.ie = s[1] : 0;
		if(Sys.ie && Sys.ie == "6.0")
		{
			isIE6 = true;
		}
		var windowWidth, windowHeight;

		if(self.innerHeight)
		{
			windowWidth = self.innerWidth;
			windowHeight = self.innerHeight;
		}
		else
		if(document.documentElement && document.documentElement.clientHeight)
		{
			windowWidth = document.documentElement.clientWidth;
			windowHeight = document.documentElement.clientHeight;
		}
		else
		if(document.body)
		{
			windowWidth = document.body.clientWidth;
			windowHeight = document.body.clientHeight;
		}
		return this.each(function()
		{
			var loc;
			var wrap = $("<div></div>");
			var top = -1;
			if(location == undefined || location.constructor == String)
			{
				switch(location)
				{
					case("r-b"):
						loc =
						{
							right : "0px",
							bottom : "0px"
						};
						break;
					case("l-b"):
						loc =
						{
							left : "0px",
							bottom : "0px"
						};
						break;
					case("l-t"):
						loc =
						{
							left : "0px",
							top : "0px"
						};
						top = 0;
						break;
					case("r-t"):
						loc =
						{
							right : "0px",
							top : "0px"
						};
						top = 0;
						break;
					case("t-m"):
						loc =
						{
							left : windowWidth / 2 - $(this).width() / 2 + "px",
							top : "0px"
						};
						top = 0;
						break;
					case("b-m"):
						loc =
						{
							left : windowWidth / 2 - $(this).width() / 2 + "px",
							bottom : "0px"
						};
						break;
					case("l-m"):
						loc =
						{
							left : "0px",
							top : windowHeight / 2 - $(this).height() / 2 + "px"
						};
						top = windowHeight / 2 - $(this).height() / 2;
						break;
					case("r-m"):
						loc =
						{
							right : "0px",
							top : windowHeight / 2 - $(this).height() / 2 + "px"
						};
						top = windowHeight / 2 - $(this).height() / 2;
						break;
					case("m"):
						var l = 0;
						var t = 0;
						l = windowWidth / 2 - $(this).width() / 2;
						t = windowHeight / 2 - $(this).height() / 2;
						top = t;
						loc =
						{
							left : l + "px",
							top : t + "px"
						};
						break;
					default:
						//default r-b
						location = "r-b";
						loc =
						{
							right : "0px",
							bottom : "0px"
						};
						break;
				}
			}
			else
			{
				loc = location;
				alert(loc.bottom);
				var str = loc.top;

				if( typeof (str) != 'undefined')
				{
					str = str.replace("px", "");
					top = str;
				}
			}
			/*fied ie6 css hack*/
			if(isIE6)
			{
				if(top >= 0)
				{
					wrap = $("<div style=\"top:expression(documentElement.scrollTop+" + top + ");\"></div>");
				}
				else
				{
					wrap = $("<div style=\"top:expression(documentElement.scrollTop+documentElement.clientHeight-this.offsetHeight);\"></div>");
				}
			}
			$("body").append(wrap);

			wrap.css(loc).css(
			{
				position : "fixed",
				z_index : "999"
			});
			if(isIE6)
			{

				wrap.css("position", "absolute");
				$("body").css("background-attachment", "fixed").css("background-image", "url('')");
			}
			$(this).appendTo(wrap);
		});
	};
})(jQuery);

var im=(function($)
{
	return {
        _uid:10062,
		_running:false,
		_sending:false,
        _lastmid:0,
		_dialog:null,
		SendOK: function(data)
		{
			im._sending=false;
			$("#im_error").hide();

            if(data==null)return;

            if(data.sender==0)data.title="I ";

            im.UpdateLog(data);

            bNotice=false;
            if(data.online===false)
            {
                data.title="System";
                data.content="No one online";
                bNotice=true;
            }
            if(data.wait===true)
            {
                data.title="System";
                data.content="Please wait...";
                bNotice=true;
            }
            if(data.failed===true)
            {
                data.title="System";
                data.content="Error";
                bNotice=true;
            }
            if(bNotice)im.UpdateLog(data);
		},
		SendErr: function(e)
		{
			im._sending=false;
			$("#im_error").show();
		},
		SendMsg:function()
		{
			if($("#im_input").val().length <= 0)return;
			if(im._running==false || im._sending==true)return;
			
			im._sending=true;
			$.ajax(
			{
				type : "POST",
				url : "im_post.php",
				dataType:"json",
				cache: false,
				async:true,
				data : $("#im_form").serialize(),
				timeout : 30000,
				error : im.SendErr,
				success : im.SendOK
			});
			$("#im_input").val("");
		},
		InputKeyDown:function(e)
		{
			if(e.keyCode===13)
			{
				e.preventDefault();
				im.SendMsg();
			}
		},
		UpdateLog:function(data)
		{
			if(im._running==false)return;

			var vHasLog=0;
            if(data!=null && data.mid>0)
            {
                vHasLog=1;

                if(im._lastmid>=data.mid)return;
                im._lastmid=data.mid;

                var d = new Date(data.time*1000);
                var sTime=d.getHours();
                if(d.getHours()<10)sTime="0"+d.getHours();
                if(d.getMinutes()<10)sTime+=":0"+d.getMinutes();
                else sTime+=":"+d.getMinutes();
                if(d.getSeconds()<10)sTime+=":0"+d.getSeconds();
                else sTime+=":"+d.getSeconds();

                var str="<div class='msg_title'>"+sTime+" ";
                str+="<span class='msg_sender'>"+data.title+"</span>: ";
                str+="</div>";
                str+="<div class='msg_content'>"+data.content+"</div>";
                str=str.replace(/\n/g,"<br />");

                $("#im_history").append(str);
            }
			if(vHasLog==1)
			{
				$('#im_history').scrollTop($('#im_history')[0].scrollHeight);
                window.setTimeout(im.Update,10);
			}
            else
            {
                window.setTimeout(im.Update,500);
            }
		},

        UpdateAgain:function(e)
        {
            if(im._running==false)return;
            window.setTimeout(im.Update,500);
        },
	
		Update:function(param)
		{
			if(im._running==false)return;
			$.ajax({  
					type: "GET",  
					url: "im_update.php?uid="+im._uid+"&mid="+im._lastmid,
					dataType:"json",
					async:true,
					cache: false,
					timeout:30000,
					success: im.UpdateLog,
                    error:im.UpdateAgain
				});
		},
	
		SaveMsg:function()
		{
			var time = new Date();
			var filename = "InsMsg WebChat - " + time.toLocaleDateString();
		
			var record = $("#im_history").html();
			var winRecord = window.open('about:blank', '_blank', 'top=500');
			winRecord.document.open("text/html", "utf-8");
			winRecord.document.write("<html><title>InsMsg WebChat</title><style>body{padding:2px;font-size:14px;}hr{height: 2px;border: none;border-bottom: 2px solid #3333FF;}div.msg_title{color: rgb(128,128,128);padding-top:5px;}span.msg_sender{color:#990000;}div.msg_content{color:#330099;padding-left: 20px;}</style><body>");
			winRecord.document.write("<h2>InsMsg WebChat</h2><hr />" + record + "</body></html>");
			winRecord.document.execCommand("SaveAs", true, filename + ".html");
		},
		
		WndResize:function()
		{
			$("#im_input").width($("#im_dlg").width() - $("#im_send").width() - 30);
			$("#im_history").height($("#im_dlg").height() - $("#im_dlg_foot").height() - $("#im_submit").height() - $("#im_menu").height() - 20);
		},

		WndClose:function()
		{
			im._running=false;
			$("#im_dlg").dialog('destroy');
			im._dialog=null;
		},
			
		WndOpen:function()
		{
			if(im._dialog!=null)return;
			
			$("#im_face").css("clip","rect(0px,16px,16px,0px)");
			$("#im_save").css("clip","rect(0px,32px,16px,16px)");
			
			
			im._dialog=$("#im_dlg").dialog(
			{
				height: 300,
				minHeight : 220,
				width: 500,
				minWidth : 380
			});
			$("#im_dlg").dialog(
			{
				resize : im.WndResize,
				resizeStop : im.WndResize,
				close : im.WndClose
			});
			im.WndResize();
			
			$("#im_send").click(im.SendMsg);
			$("#im_input").keydown(im.InputKeyDown);
			
			
			im._running=true;
			$.cookie('msgid','0');
			$("#im_history").html('');
			im.Update();
		}
	}
})(jQuery);

$(document).ready(function()
{
	$("#im_entry").static_div("l-m");
	$("#im_entry").css("display","block");
	$("#im_open").click(im.WndOpen);
	$("#im_save").click(im.SaveMsg);
});


